import React from 'react';
import { createRoot } from 'react-dom/client';

export type TmFv1DParams = {
    elementId: string,
    url: string,
    side1: string,
    trackWidth?: number,
    rowTitleWidth?: number
};

export class TmFv1D extends React.Component {

    protected containerRef = React.createRef<HTMLDivElement>();

    public constructor(props: TmFv1DParams) {
        super(props);
    }

    public componentDidMount(): void {
        new ResizeObserver(this.resize)
            .observe(this.containerRef.current as Element);
    }

    resize() {
        console.log('Observer works');
    }

    public render(): JSX.Element {
        return (
            <div ref={this.containerRef} style={{ borderWidth: "1px", borderStyle: "solid", borderBlockColor: "black" }}>
                Hello
            </div>
        );
    }

}

export class TmFv1DElement extends HTMLElement {

    constructor() {
        super();
        const root = createRoot(this);
        root.render(
            <TmFv1D></TmFv1D>
        );
    }
}
